from typing import Any
from fastapi import APIRouter, Depends

from index import endpoints_index
from events.areas.cluster import AreaRouterCluster

from api_validations.defaults.validations import CommonHeaders
from api_validations.response.pagination import PaginateOnly
from api_middlewares.token_provider import TokenProvider


area_endpoint_route = APIRouter(prefix="/areas", tags=["Areas Cluster"])

area_list = "AreaList"
@area_endpoint_route.post(
    path="/list",
    description="List all areas endpoint",
    operation_id=endpoints_index[area_list],
)
def area_list_route(data: PaginateOnly, headers: CommonHeaders = Depends(CommonHeaders.as_dependency)):
    token_object = TokenProvider.get_dict_from_redis(token=headers.token)
    event_founder_dict = dict(endpoint_code=headers.operation_id, token=token_object)
    event_key = TokenProvider.retrieve_event_codes(**event_founder_dict)
    FoundCluster = AreaRouterCluster.get_event_cluster(area_list)
    event_cluster_matched = FoundCluster.match_event(event_key=event_key)
    return event_cluster_matched.event_callable(list_options=data, headers=headers)


area_create = "AreaCreate"
@area_endpoint_route.post(
    path="/create",
    description="Create area endpoint",
    operation_id=endpoints_index[area_create],
)
def area_create_route(data, headers: CommonHeaders = Depends(CommonHeaders.as_dependency)):
    token_object = TokenProvider.get_dict_from_redis(token=headers.token)
    event_founder_dict = dict(endpoint_code=headers.operation_id, token=token_object)
    event_key = TokenProvider.retrieve_event_codes(**event_founder_dict)
    FoundCluster = AreaRouterCluster.get_event_cluster(area_create)
    event_cluster_matched = FoundCluster.match_event(event_key=event_key)
    return event_cluster_matched.event_callable(data=data, headers=headers)


area_update = "AreaUpdate"
@area_endpoint_route.post(
    path="/update/{uu_id}",
    description="Update area endpoint",
    operation_id=endpoints_index[area_update],
)
def area_update_route(uu_id: str, data, headers: CommonHeaders = Depends(CommonHeaders.as_dependency)):
    token_object = TokenProvider.get_dict_from_redis(token=headers.token)
    event_founder_dict = dict(endpoint_code=headers.operation_id, token=token_object)
    event_key = TokenProvider.retrieve_event_codes(**event_founder_dict)
    FoundCluster = AreaRouterCluster.get_event_cluster(area_update)
    event_cluster_matched = FoundCluster.match_event(event_key=event_key)
    return event_cluster_matched.event_callable(uu_id=uu_id, data=data, headers=headers)


area_delete = "AreaDelete"
@area_endpoint_route.post(
    path="/delete/{uu_id}",
    description="Delete area endpoint",
    operation_id=endpoints_index[area_delete],
)
def area_delete_route(uu_id: str, headers: CommonHeaders = Depends(CommonHeaders.as_dependency)):
    token_object = TokenProvider.get_dict_from_redis(token=headers.token)
    event_founder_dict = dict(endpoint_code=headers.operation_id, token=token_object)
    event_key = TokenProvider.retrieve_event_codes(**event_founder_dict)
    FoundCluster = AreaRouterCluster.get_event_cluster(area_delete)
    event_cluster_matched = FoundCluster.match_event(event_key=event_key)
    return event_cluster_matched.event_callable(uu_id=uu_id, headers=headers)
